
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef MPC_avoidObs_ERROR_H
#define MPC_avoidObs_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_MPC_avoidObs    (24571)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_MPC_avoidObs_UNVALID_PARAMETERS   H2_ENCODE_ERR(M_MPC_avoidObs, 1)
#define S_MPC_avoidObs_DISTMAP_NOT_FOUND    H2_ENCODE_ERR(M_MPC_avoidObs, 2)
#define S_MPC_avoidObs_STRAJ_NOT_FOUND      H2_ENCODE_ERR(M_MPC_avoidObs, 3)
#define S_MPC_avoidObs_POM_NOT_FOUND        H2_ENCODE_ERR(M_MPC_avoidObs, 4)
#define S_MPC_avoidObs_PATH_POSTER_READ     H2_ENCODE_ERR(M_MPC_avoidObs, 5)
#define S_MPC_avoidObs_SYS_UNDEFINED        H2_ENCODE_ERR(M_MPC_avoidObs, 6)
#define S_MPC_avoidObs_DEM_POSTER_READ      H2_ENCODE_ERR(M_MPC_avoidObs, 7)
#define S_MPC_avoidObs_POM_POSTER_READ      H2_ENCODE_ERR(M_MPC_avoidObs, 8)
#define S_MPC_avoidObs_NO_TRAJ              H2_ENCODE_ERR(M_MPC_avoidObs, 9)
#define S_MPC_avoidObs_POSTER_READ          H2_ENCODE_ERR(M_MPC_avoidObs, 10)
#define S_MPC_avoidObs_BLOCKED              H2_ENCODE_ERR(M_MPC_avoidObs, 11)
#define S_MPC_avoidObs_NO_PATH              H2_ENCODE_ERR(M_MPC_avoidObs, 12)
#define S_MPC_avoidObs_POSTER_NOT_FOUND     H2_ENCODE_ERR(M_MPC_avoidObs, 13)


/* std errors */
#define S_MPC_avoidObs_stdGenoM_ACTIVITY_INTERRUPTED       1610343425   /* 24571<<16 | 0x8000 | 100<<8 | 1 */
#define S_MPC_avoidObs_stdGenoM_TOO_MANY_ACTIVITIES        1610343426   /* 24571<<16 | 0x8000 | 100<<8 | 2 */
#define S_MPC_avoidObs_stdGenoM_ACTIVITY_FAILED            1610343427   /* 24571<<16 | 0x8000 | 100<<8 | 3 */
#define S_MPC_avoidObs_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 1610343428   /* 24571<<16 | 0x8000 | 100<<8 | 4 */
#define S_MPC_avoidObs_stdGenoM_UNKNOWN_ACTIVITY           1610343429   /* 24571<<16 | 0x8000 | 100<<8 | 5 */
#define S_MPC_avoidObs_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 1610343430   /* 24571<<16 | 0x8000 | 100<<8 | 6 */
#define S_MPC_avoidObs_stdGenoM_SYSTEM_ERROR               1610343431   /* 24571<<16 | 0x8000 | 100<<8 | 7 */
#define S_MPC_avoidObs_stdGenoM_ACTIVITY_ALREADY_ENDED     1610343432   /* 24571<<16 | 0x8000 | 100<<8 | 8 */
#define S_MPC_avoidObs_stdGenoM_WAIT_INIT_RQST             1610343433   /* 24571<<16 | 0x8000 | 100<<8 | 9 */
#define S_MPC_avoidObs_stdGenoM_CONTROL_CODEL_ERROR        1610343434   /* 24571<<16 | 0x8000 | 100<<8 | 10 */
#define S_MPC_avoidObs_stdGenoM_EXEC_TASK_SUSPENDED        1610343435   /* 24571<<16 | 0x8000 | 100<<8 | 11 */
#define S_MPC_avoidObs_stdGenoM_BAD_BLOCK_TYPE             1610343436   /* 24571<<16 | 0x8000 | 100<<8 | 12 */
#define S_MPC_avoidObs_stdGenoM_BAD_POSTER_TYPE            1610343437   /* 24571<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define MPC_AVOIDOBS_H2_ERR_MSGS {\
    {"UNVALID_PARAMETERS", 1}, \
    {"DISTMAP_NOT_FOUND", 2},\
    {"STRAJ_NOT_FOUND", 3},\
    {"POM_NOT_FOUND", 4},\
    {"PATH_POSTER_READ", 5},\
    {"SYS_UNDEFINED", 6},\
    {"DEM_POSTER_READ", 7},\
    {"POM_POSTER_READ", 8},\
    {"NO_TRAJ", 9},\
    {"POSTER_READ", 10},\
    {"BLOCKED", 11},\
    {"NO_PATH", 12},\
    {"POSTER_NOT_FOUND", 13},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int MPC_avoidObsRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
