
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_avoidObs_MSG_LIB_H
#define MPC_avoidObs_MSG_LIB_H

#include "portLib.h"
#include "csLib.h"
#include "posterLib.h"
 
#include "MPC_avoidObsType.h"

#define TIME_WAIT_REPLY           /*2000*/ 0
 



/*----------- Tailles des messages et boites aux lettres  ----------*/

/* Taille du buffer utilise dans la bal pour un mesage de taille size
 * (cf servMbox pour UNIX et h2rgnLib pour VXWORKS )
 */


#define BUF_SIZE(size) \
   (size + 4 - (size & 3) + sizeof(LETTER_HDR) + 8)

/**
 ** Boite aux lettres reception requetes 
 **/
#define  MPC_AVOIDOBS_MBOX_NAME                  genomInstanceName("MPC_avoidObs")

#define  MPC_AVOIDOBS_MAX_RQST_SIZE              1544

#define  MPC_AVOIDOBS_MBOX_RQST_SIZE       \
 (BUF_SIZE(MPC_AVOIDOBS_MAX_RQST_SIZE) * SERV_NMAX_RQST_ID)

/** 
 ** Taille max repliques (serveur)
 **/
#define  MPC_AVOIDOBS_MAX_INTERMED_REPLY_SIZE   (sizeof(int))

#define  MPC_AVOIDOBS_MAX_REPLY_SIZE             8

/** 
 ** Taille bal clients pour reception repliques 
 **/
#define  MPC_AVOIDOBS_CLIENT_MBOX_REPLY_SIZE   \
((BUF_SIZE(MPC_AVOIDOBS_MAX_REPLY_SIZE) \
   + BUF_SIZE(MPC_AVOIDOBS_MAX_INTERMED_REPLY_SIZE)) \
 * CLIENT_NMAX_RQST_ID)

/*-------------------------- Liste des requetes  -------------------------*/

#define MPC_AVOIDOBS_INIT_RQST 0
#define MPC_AVOIDOBS_SETMANASYS_RQST 1
#define MPC_AVOIDOBS_SETGOTOOPTIONS_RQST 2
#define MPC_AVOIDOBS_SIMPLEGOTO_RQST 3
#define MPC_AVOIDOBS_SETTRAJSELOPTIONS_RQST 4
#define MPC_AVOIDOBS_SETMANATRAJSELOPTIONS_RQST 5
#define MPC_AVOIDOBS_TRAJSELTO_RQST 6
#define MPC_AVOIDOBS_ADDWAYPOINT_RQST 7
#define MPC_AVOIDOBS_TRACK_RQST 8
#define MPC_AVOIDOBS_STOP_RQST 9
#define MPC_AVOIDOBS_SETATFPARAMS_RQST 10
#define MPC_AVOIDOBS_AVOIDTF_RQST 11
#define MPC_AVOIDOBS_KEEPLATSHIFT_RQST 12
#define MPC_AVOIDOBS_SETROBUFASTCOMPARAMS_RQST 13
#define MPC_AVOIDOBS_STARTATG_TCP_SERVER_RQST 14
#define MPC_AVOIDOBS_STOPATG_TCP_SERVER_RQST 15
#define MPC_AVOIDOBS_SETVELFEEDBACKMODE_RQST 16
#define MPC_AVOIDOBS_SETTFPARAMS_RQST 17
#define MPC_AVOIDOBS_FOLLOWTRAJ_RQST 18
#define MPC_AVOIDOBS_SETDISTMAPOPTIONS_RQST 19
#define MPC_AVOIDOBS_SETDISPLAYPOSTERSOPTION_RQST 20
#define MPC_AVOIDOBS_SETDISPLAYTIMEROPTION_RQST 21
#define MPC_AVOIDOBS_ABORT_RQST 22


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

STATUS MPC_avoidObsClientInit (CLIENT_ID *pClientId);

STATUS MPC_avoidObsClientEnd (CLIENT_ID clientId);

int MPC_avoidObsAbortRqstSend (CLIENT_ID clientId, 
			   int *pRqstId,
			   int *activity,
			   int replyTimeOut);

int MPC_avoidObsAbortReplyRcv (CLIENT_ID clientId, 
			   int rqstId, 
			   int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			   int *bilan);

int MPC_avoidObsAbortRqstAndRcv (CLIENT_ID clientId, 
			     int *activity,
			     int *bilan);




extern STATUS MPC_avoidObsInitRqstSend (CLIENT_ID clientId, int *pRqstId,
					 OA_INIT_I *(in_Init_I),
					 int replyTimeOut);

extern int MPC_avoidObsInitReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsInitRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					OA_INIT_I *(in_Init_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsInitRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					OA_INIT_I *(in_Init_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsSetManaSysRqstSend (CLIENT_ID clientId, int *pRqstId,
					 OA_SETMANASYS_I *(in_SetManaSys_I),
					 int replyTimeOut);

extern int MPC_avoidObsSetManaSysReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsSetManaSysRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					OA_SETMANASYS_I *(in_SetManaSys_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsSetManaSysRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					OA_SETMANASYS_I *(in_SetManaSys_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsSetGoToOptionsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 OA_GOTO_INIT_I *(in_OA_GoTo_Init_I),
					 int replyTimeOut);

int MPC_avoidObsSetGoToOptionsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsSetGoToOptionsRqstAndRcv (CLIENT_ID clientId, 
				 OA_GOTO_INIT_I *(in_OA_GoTo_Init_I), 
				 
				 int *bilan);




extern STATUS MPC_avoidObsSimpleGoToRqstSend (CLIENT_ID clientId, int *pRqstId,
					 TRAJSEL_I *(in_Goto_I),
					 int replyTimeOut);

extern int MPC_avoidObsSimpleGoToReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsSimpleGoToRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					TRAJSEL_I *(in_Goto_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsSimpleGoToRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					TRAJSEL_I *(in_Goto_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsSetTrajSelOptionsRqstSend (CLIENT_ID clientId, int *pRqstId,
					 OA_TRAJSEL_OPTIONS_I *(in_OA_TrajSel_Options_I),
					 int replyTimeOut);

extern int MPC_avoidObsSetTrajSelOptionsReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsSetTrajSelOptionsRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					OA_TRAJSEL_OPTIONS_I *(in_OA_TrajSel_Options_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsSetTrajSelOptionsRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					OA_TRAJSEL_OPTIONS_I *(in_OA_TrajSel_Options_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsSetManaTrajSelOptionsRqstSend (CLIENT_ID clientId, int *pRqstId,
					 OA_MANATRAJSEL_OPTIONS_I *(in_OA_ManaTrajSel_Options_I),
					 int replyTimeOut);

extern int MPC_avoidObsSetManaTrajSelOptionsReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsSetManaTrajSelOptionsRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					OA_MANATRAJSEL_OPTIONS_I *(in_OA_ManaTrajSel_Options_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsSetManaTrajSelOptionsRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					OA_MANATRAJSEL_OPTIONS_I *(in_OA_ManaTrajSel_Options_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsTrajSelToRqstSend (CLIENT_ID clientId, int *pRqstId,
					 TRAJSEL_I *(in_Goto_I),
					 int replyTimeOut);

extern int MPC_avoidObsTrajSelToReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsTrajSelToRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					TRAJSEL_I *(in_Goto_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsTrajSelToRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					TRAJSEL_I *(in_Goto_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsAddWayPointRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 WP2D *(in_AddWayPoint_I),
					 int replyTimeOut);

int MPC_avoidObsAddWayPointReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsAddWayPointRqstAndRcv (CLIENT_ID clientId, 
				 WP2D *(in_AddWayPoint_I), 
				 
				 int *bilan);




extern STATUS MPC_avoidObsTrackRqstSend (CLIENT_ID clientId, int *pRqstId,
					 TRACK_I *(in_Track_I),
					 int replyTimeOut);

extern int MPC_avoidObsTrackReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsTrackRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					TRACK_I *(in_Track_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsTrackRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					TRACK_I *(in_Track_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsStopRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int MPC_avoidObsStopReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsStopRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);




extern STATUS MPC_avoidObsSetATFParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 ATFPARAMS_I *(in_ATFParams_I),
					 int replyTimeOut);

int MPC_avoidObsSetATFParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsSetATFParamsRqstAndRcv (CLIENT_ID clientId, 
				 ATFPARAMS_I *(in_ATFParams_I), 
				 
				 int *bilan);




extern STATUS MPC_avoidObsAvoidTFRqstSend (CLIENT_ID clientId, int *pRqstId,
					 AVOIDTF_I *(in_AvoidTF_I),
					 int replyTimeOut);

extern int MPC_avoidObsAvoidTFReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsAvoidTFRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					AVOIDTF_I *(in_AvoidTF_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsAvoidTFRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					AVOIDTF_I *(in_AvoidTF_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsKeepLatShiftRqstSend (CLIENT_ID clientId, int *pRqstId,
					 KEEP_SHIFT_I *(in_Keep_shift_I),
					 int replyTimeOut);

extern int MPC_avoidObsKeepLatShiftReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsKeepLatShiftRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					KEEP_SHIFT_I *(in_Keep_shift_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsKeepLatShiftRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					KEEP_SHIFT_I *(in_Keep_shift_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsSetRobufastComParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 ROBUFAST_COM_PARAMS_I *(in_RobufastComParams_I),
					 int replyTimeOut);

int MPC_avoidObsSetRobufastComParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsSetRobufastComParamsRqstAndRcv (CLIENT_ID clientId, 
				 ROBUFAST_COM_PARAMS_I *(in_RobufastComParams_I), 
				 
				 int *bilan);




extern STATUS MPC_avoidObsStartATG_tcp_serverRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int MPC_avoidObsStartATG_tcp_serverReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsStartATG_tcp_serverRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int MPC_avoidObsStartATG_tcp_serverRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsStopATG_tcp_serverRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int MPC_avoidObsStopATG_tcp_serverReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsStopATG_tcp_serverRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int MPC_avoidObsStopATG_tcp_serverRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsSetVelFeedbackModeRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 VELFEEDBACKMODE_I *(in_vel_feedback_I),
					 int replyTimeOut);

int MPC_avoidObsSetVelFeedbackModeReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsSetVelFeedbackModeRqstAndRcv (CLIENT_ID clientId, 
				 VELFEEDBACKMODE_I *(in_vel_feedback_I), 
				 
				 int *bilan);




extern STATUS MPC_avoidObsSetTFParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 TFPARAMS_I *(in_TFParams_I),
					 int replyTimeOut);

int MPC_avoidObsSetTFParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsSetTFParamsRqstAndRcv (CLIENT_ID clientId, 
				 TFPARAMS_I *(in_TFParams_I), 
				 
				 int *bilan);




extern STATUS MPC_avoidObsFollowTrajRqstSend (CLIENT_ID clientId, int *pRqstId,
					 FOLLOWTRAJ_I *(in_FollowTraj_I),
					 int replyTimeOut);

extern int MPC_avoidObsFollowTrajReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_avoidObsFollowTrajRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					FOLLOWTRAJ_I *(in_FollowTraj_I), 
					
					int *activity, int *bilan);

extern int MPC_avoidObsFollowTrajRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					FOLLOWTRAJ_I *(in_FollowTraj_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_avoidObsSetDistMapOptionsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 DISTMAPOPTIONS_I *(in_DistMapOptions_I),
					 int replyTimeOut);

int MPC_avoidObsSetDistMapOptionsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsSetDistMapOptionsRqstAndRcv (CLIENT_ID clientId, 
				 DISTMAPOPTIONS_I *(in_DistMapOptions_I), 
				 
				 int *bilan);




extern STATUS MPC_avoidObsSetDisplayPostersOptionRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 int *(in_FILL_DISPLAY_POSTERS),
					 int replyTimeOut);

int MPC_avoidObsSetDisplayPostersOptionReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsSetDisplayPostersOptionRqstAndRcv (CLIENT_ID clientId, 
				 int *(in_FILL_DISPLAY_POSTERS), 
				 
				 int *bilan);




extern STATUS MPC_avoidObsSetDisplayTimerOptionRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 int *(in_display_time),
					 int replyTimeOut);

int MPC_avoidObsSetDisplayTimerOptionReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_avoidObsSetDisplayTimerOptionRqstAndRcv (CLIENT_ID clientId, 
				 int *(in_display_time), 
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* MPC_avoidObs_MSG_LIB_H */

