
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_avoidObs_POSTER_LIB_H
#define MPC_avoidObs_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "MPC_avoidObsType.h"
#include "MPC_avoidObsError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[MPC_AVOIDOBS_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} MPC_AVOIDOBS_CNTRL_STR;

/* For consistency with other posters */
typedef MPC_AVOIDOBS_CNTRL_STR MPC_AVOIDOBS_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "MPC_avoidObsPosterLibStruct.h"



/* Posters */
#define MPC_AVOIDOBS_CNTRL_POSTER_NAME genomInstanceSuffixName("MPC_avoidObs", "Cntrl")
#define MPC_AVOIDOBS_MODE_POSTER_NAME genomInstanceSuffixName("MPC_avoidObs", "Mode")
#define MPC_AVOIDOBS_CTRAJ_POSTER_NAME genomInstanceSuffixName("MPC_avoidObs", "CTraj")
#define MPC_AVOIDOBS_STRAJ_POSTER_NAME genomInstanceSuffixName("MPC_avoidObs", "STraj")
#define MPC_AVOIDOBS_BESTPATHTS_POSTER_NAME genomInstanceSuffixName("MPC_avoidObs", "BestPathTS")
#define MPC_AVOIDOBS_CANDPATHTS_POSTER_NAME genomInstanceSuffixName("MPC_avoidObs", "CandPathTS")
#define MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_NAME genomInstanceSuffixName("MPC_avoidObs", "ATFwaypoints")
#define MPC_AVOIDOBS_DISTOBSMAP_POSTER_NAME genomInstanceSuffixName("MPC_avoidObs", "DistObsMap")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS MPC_avoidObsPosterInit ( void );
extern POSTER_ID MPC_avoidObsCntrlPosterID ();
extern STATUS MPC_avoidObsCntrlPosterRead ( MPC_AVOIDOBS_CNTRL_STR *MPC_avoidObsCntrlStrId );
extern STATUS MPC_avoidObsCntrlPosterInit ( void );
extern STATUS MPC_avoidObsCntrlInstancePosterRead(const char *name, MPC_AVOIDOBS_CNTRL_STR *MPC_avoidObsCntrlStrId);
extern STATUS MPC_avoidObsModePosterInit ( void );
extern POSTER_ID MPC_avoidObsModePosterID ( void );
extern STATUS MPC_avoidObsModePosterRead ( MPC_AVOIDOBS_MODE_POSTER_STR *x );
extern STATUS MPC_avoidObsModeInstancePosterRead ( const char *, MPC_AVOIDOBS_MODE_POSTER_STR * );
extern STATUS MPC_avoidObsModemodePosterRead ( int *mode );
extern STATUS MPC_avoidObsModemodeInstancePosterRead( const char *, int * );
extern STATUS MPC_avoidObsCTrajPosterInit ( void );
extern POSTER_ID MPC_avoidObsCTrajPosterID ( void );
extern STATUS MPC_avoidObsCTrajPosterRead ( MPC_AVOIDOBS_CTRAJ_POSTER_STR *x );
extern STATUS MPC_avoidObsCTrajInstancePosterRead ( const char *, MPC_AVOIDOBS_CTRAJ_POSTER_STR * );
extern STATUS MPC_avoidObsCTrajctrajPosterRead ( MANA_PCTRAJ *ctraj );
extern STATUS MPC_avoidObsCTrajctrajInstancePosterRead( const char *, MANA_PCTRAJ * );
extern STATUS MPC_avoidObsSTrajPosterInit ( void );
extern POSTER_ID MPC_avoidObsSTrajPosterID ( void );
extern STATUS MPC_avoidObsSTrajPosterRead ( MPC_AVOIDOBS_STRAJ_POSTER_STR *x );
extern STATUS MPC_avoidObsSTrajInstancePosterRead ( const char *, MPC_AVOIDOBS_STRAJ_POSTER_STR * );
extern STATUS MPC_avoidObsSTrajstrajPosterRead ( MANA_PSTRAJ *straj );
extern STATUS MPC_avoidObsSTrajstrajInstancePosterRead( const char *, MANA_PSTRAJ * );
extern STATUS MPC_avoidObsBestPathTSPosterInit ( void );
extern POSTER_ID MPC_avoidObsBestPathTSPosterID ( void );
extern STATUS MPC_avoidObsBestPathTSPosterRead ( MPC_AVOIDOBS_BESTPATHTS_POSTER_STR *x );
extern STATUS MPC_avoidObsBestPathTSInstancePosterRead ( const char *, MPC_AVOIDOBS_BESTPATHTS_POSTER_STR * );
extern STATUS MPC_avoidObsBestPathTSbestPathPosterRead ( GEN_PATH_XY *bestPath );
extern STATUS MPC_avoidObsBestPathTSbestPathInstancePosterRead( const char *, GEN_PATH_XY * );
extern STATUS MPC_avoidObsCandPathTSPosterInit ( void );
extern POSTER_ID MPC_avoidObsCandPathTSPosterID ( void );
extern STATUS MPC_avoidObsCandPathTSPosterRead ( MPC_AVOIDOBS_CANDPATHTS_POSTER_STR *x );
extern STATUS MPC_avoidObsCandPathTSInstancePosterRead ( const char *, MPC_AVOIDOBS_CANDPATHTS_POSTER_STR * );
extern STATUS MPC_avoidObsCandPathTStabCandPath_userPosterRead ( TAB_CAND_PATH *tabCandPath_user );
extern STATUS MPC_avoidObsCandPathTStabCandPath_userInstancePosterRead( const char *, TAB_CAND_PATH * );
extern STATUS MPC_avoidObsATFwaypointsPosterInit ( void );
extern POSTER_ID MPC_avoidObsATFwaypointsPosterID ( void );
extern STATUS MPC_avoidObsATFwaypointsPosterRead ( MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR *x );
extern STATUS MPC_avoidObsATFwaypointsInstancePosterRead ( const char *, MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR * );
extern STATUS MPC_avoidObsATFwaypointsatf_waypoints_userPosterRead ( PL_PATH_XY *atf_waypoints_user );
extern STATUS MPC_avoidObsATFwaypointsatf_waypoints_userInstancePosterRead( const char *, PL_PATH_XY * );
extern STATUS MPC_avoidObsDistObsMapPosterInit ( void );
extern POSTER_ID MPC_avoidObsDistObsMapPosterID ( void );
extern STATUS MPC_avoidObsDistObsMapPosterRead ( MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR *x );
extern STATUS MPC_avoidObsDistObsMapInstancePosterRead ( const char *, MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR * );
extern STATUS MPC_avoidObsDistObsMapdistObsMap_userPosterRead ( DIST_OBS_MAP *distObsMap_user );
extern STATUS MPC_avoidObsDistObsMapdistObsMap_userInstancePosterRead( const char *, DIST_OBS_MAP * );
#ifdef __cplusplus
}
#endif
#endif

