
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * Sara Fleury
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_AVOIDOBS_PRINTXML_H
#define MPC_AVOIDOBS_PRINTXML_H

#include "genom/printScan.h"
#include "genom/printXMLProto.h"

/* Structures definies par d'autres modules */

#include "server/MPC_plannerPrintXML.h"

#include "server/MPC_DEMTreatmentPrintXML.h"

#include "server/dtmPrintXML.h"

#include "server/pomPrintXML.h"

#include "server/genPosPrintXML.h"


#include "MPC_avoidObsPosterLib.h"

/* Prototypes */
extern void printXML_struct_MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR ( FILE *out, char *name,
     struct MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR ( FILE *out, char *name,
     struct MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_AVOIDOBS_CANDPATHTS_POSTER_STR ( FILE *out, char *name,
     struct MPC_AVOIDOBS_CANDPATHTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_AVOIDOBS_BESTPATHTS_POSTER_STR ( FILE *out, char *name,
     struct MPC_AVOIDOBS_BESTPATHTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_AVOIDOBS_STRAJ_POSTER_STR ( FILE *out, char *name,
     struct MPC_AVOIDOBS_STRAJ_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_AVOIDOBS_CTRAJ_POSTER_STR ( FILE *out, char *name,
     struct MPC_AVOIDOBS_CTRAJ_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_AVOIDOBS_MODE_POSTER_STR ( FILE *out, char *name,
     struct MPC_AVOIDOBS_MODE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MPC_AVOID_STR ( FILE *out, char *name,
     struct MPC_AVOID_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_VELFEEDBACKMODE_I ( FILE *out, char *name,
     struct VELFEEDBACKMODE_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_DISTMAPOPTIONS_I ( FILE *out, char *name,
     struct DISTMAPOPTIONS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_FOLLOWTRAJ_I ( FILE *out, char *name,
     struct FOLLOWTRAJ_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_TFPARAMS_I ( FILE *out, char *name,
     struct TFPARAMS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_KEEP_SHIFT_I ( FILE *out, char *name,
     struct KEEP_SHIFT_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ATGPARAMS_I ( FILE *out, char *name,
     struct ATGPARAMS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_AVOIDTF_I ( FILE *out, char *name,
     struct AVOIDTF_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ATFPARAMS_I ( FILE *out, char *name,
     struct ATFPARAMS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_TRACK_I ( FILE *out, char *name,
     struct TRACK_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OA_MANATRAJSEL_OPTIONS_I ( FILE *out, char *name,
     struct OA_MANATRAJSEL_OPTIONS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OA_TRAJSEL_OPTIONS_I ( FILE *out, char *name,
     struct OA_TRAJSEL_OPTIONS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OA_SETMANASYS_I ( FILE *out, char *name,
     struct OA_SETMANASYS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_TRAJSEL_I ( FILE *out, char *name,
     struct TRAJSEL_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OA_GOTO_INIT_I ( FILE *out, char *name,
     struct OA_GOTO_INIT_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OA_INIT_I ( FILE *out, char *name,
     struct OA_INIT_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_LIST_WP ( FILE *out, char *name,
     struct LIST_WP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_WP2D ( FILE *out, char *name,
     struct WP2D *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_TAB_CAND_PATH ( FILE *out, char *name,
     struct TAB_CAND_PATH *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_CAND_PATH_XY ( FILE *out, char *name,
     struct CAND_PATH_XY *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MANA_PSTRAJ ( FILE *out, char *name,
     struct MANA_PSTRAJ *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_MANA_PCTRAJ ( FILE *out, char *name,
     struct MANA_PCTRAJ *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_TIMEV ( FILE *out, char *name,
     struct TIMEV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_POLY_MULTIITV ( FILE *out, char *name,
     struct POLY_MULTIITV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_POLY_ITV ( FILE *out, char *name,
     struct POLY_ITV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ITV ( FILE *out, char *name,
     struct ITV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_POLYNOME4 ( FILE *out, char *name,
     struct POLYNOME4 *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_GPSNovatel_FLAG ( FILE *out, char *name,
     enum GPSNovatel_FLAG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_GPS_LOG_FORMAT ( FILE *out, char *name,
     enum GPS_LOG_FORMAT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_HEADINGb_LOG ( FILE *out, char *name,
     struct HEADINGb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OEM6HEADINGb_LOG ( FILE *out, char *name,
     struct OEM6HEADINGb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_BESTXYZb_LOG ( FILE *out, char *name,
     struct BESTXYZb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OEM4BESTXYZb_LOG ( FILE *out, char *name,
     struct OEM4BESTXYZb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_BESTVELb_LOG ( FILE *out, char *name,
     struct BESTVELb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OEM4BESTVELb_LOG ( FILE *out, char *name,
     struct OEM4BESTVELb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_BESTUTMb_LOG ( FILE *out, char *name,
     struct BESTUTMb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OEM4BESTUTMb_LOG ( FILE *out, char *name,
     struct OEM4BESTUTMb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_BESTPOSb_LOG ( FILE *out, char *name,
     struct BESTPOSb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OEM4BESTPOSb_LOG ( FILE *out, char *name,
     struct OEM4BESTPOSb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_OEM4_BINARY_HEADER ( FILE *out, char *name,
     struct OEM4_BINARY_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void printXML_OEM4_BINARY_HEADER ( FILE *out, char *name,
     OEM4_BINARY_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OEM4BESTPOSb_LOG ( FILE *out, char *name,
     OEM4BESTPOSb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_BESTPOSb_LOG ( FILE *out, char *name,
     BESTPOSb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OEM4BESTUTMb_LOG ( FILE *out, char *name,
     OEM4BESTUTMb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_BESTUTMb_LOG ( FILE *out, char *name,
     BESTUTMb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OEM4BESTVELb_LOG ( FILE *out, char *name,
     OEM4BESTVELb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_BESTVELb_LOG ( FILE *out, char *name,
     BESTVELb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OEM4BESTXYZb_LOG ( FILE *out, char *name,
     OEM4BESTXYZb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_BESTXYZb_LOG ( FILE *out, char *name,
     BESTXYZb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OEM6HEADINGb_LOG ( FILE *out, char *name,
     OEM6HEADINGb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_HEADINGb_LOG ( FILE *out, char *name,
     HEADINGb_LOG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_GPS_LOG_FORMAT ( FILE *out, char *name,
     GPS_LOG_FORMAT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_GPSNovatel_FLAG ( FILE *out, char *name,
     GPSNovatel_FLAG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_POLYNOME4 ( FILE *out, char *name,
     POLYNOME4 *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ITV ( FILE *out, char *name,
     ITV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_POLY_ITV ( FILE *out, char *name,
     POLY_ITV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_POLY_MULTIITV ( FILE *out, char *name,
     POLY_MULTIITV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_TIMEV ( FILE *out, char *name,
     TIMEV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MANA_PCTRAJ ( FILE *out, char *name,
     MANA_PCTRAJ *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MANA_PSTRAJ ( FILE *out, char *name,
     MANA_PSTRAJ *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_CAND_PATH_XY ( FILE *out, char *name,
     CAND_PATH_XY *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_TAB_CAND_PATH ( FILE *out, char *name,
     TAB_CAND_PATH *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_WP2D ( FILE *out, char *name,
     WP2D *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_LIST_WP ( FILE *out, char *name,
     LIST_WP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OA_INIT_I ( FILE *out, char *name,
     OA_INIT_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OA_GOTO_INIT_I ( FILE *out, char *name,
     OA_GOTO_INIT_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_TRAJSEL_I ( FILE *out, char *name,
     TRAJSEL_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OA_SETMANASYS_I ( FILE *out, char *name,
     OA_SETMANASYS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OA_TRAJSEL_OPTIONS_I ( FILE *out, char *name,
     OA_TRAJSEL_OPTIONS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_OA_MANATRAJSEL_OPTIONS_I ( FILE *out, char *name,
     OA_MANATRAJSEL_OPTIONS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_TRACK_I ( FILE *out, char *name,
     TRACK_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ATFPARAMS_I ( FILE *out, char *name,
     ATFPARAMS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_AVOIDTF_I ( FILE *out, char *name,
     AVOIDTF_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ROBUFAST_COM_PARAMS_I ( FILE *out, char *name,
     ROBUFAST_COM_PARAMS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_KEEP_SHIFT_I ( FILE *out, char *name,
     KEEP_SHIFT_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_TFPARAMS_I ( FILE *out, char *name,
     TFPARAMS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_FOLLOWTRAJ_I ( FILE *out, char *name,
     FOLLOWTRAJ_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_DISTMAPOPTIONS_I ( FILE *out, char *name,
     DISTMAPOPTIONS_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_VELFEEDBACKMODE_I ( FILE *out, char *name,
     VELFEEDBACKMODE_I *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_AVOID_STR ( FILE *out, char *name,
     MPC_AVOID_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_AVOIDOBS_MODE_POSTER_STR ( FILE *out, char *name,
     MPC_AVOIDOBS_MODE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_AVOIDOBS_CTRAJ_POSTER_STR ( FILE *out, char *name,
     MPC_AVOIDOBS_CTRAJ_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_AVOIDOBS_STRAJ_POSTER_STR ( FILE *out, char *name,
     MPC_AVOIDOBS_STRAJ_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_AVOIDOBS_BESTPATHTS_POSTER_STR ( FILE *out, char *name,
     MPC_AVOIDOBS_BESTPATHTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_AVOIDOBS_CANDPATHTS_POSTER_STR ( FILE *out, char *name,
     MPC_AVOIDOBS_CANDPATHTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR ( FILE *out, char *name,
     MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR ( FILE *out, char *name,
     MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );

#endif /* MPC_AVOIDOBS_PRINT_XML_H */

