
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_AVOIDOBS_SCAN_H
#define MPC_AVOIDOBS_SCAN_H

#include "genom/printScan.h"

/* Structures definies par d'autres modules */

#include "server/MPC_plannerScan.h"

#include "server/MPC_DEMTreatmentScan.h"

#include "server/dtmScan.h"

#include "server/pomScan.h"

#include "server/genPosScan.h"


/* Structures du module */
#include "MPC_avoidObsPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
extern int scan_struct_MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR ( FILE *in, FILE *out,
       struct MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR ( FILE *in, FILE *out,
       struct MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_MPC_AVOIDOBS_CANDPATHTS_POSTER_STR ( FILE *in, FILE *out,
       struct MPC_AVOIDOBS_CANDPATHTS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_MPC_AVOIDOBS_BESTPATHTS_POSTER_STR ( FILE *in, FILE *out,
       struct MPC_AVOIDOBS_BESTPATHTS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_MPC_AVOIDOBS_STRAJ_POSTER_STR ( FILE *in, FILE *out,
       struct MPC_AVOIDOBS_STRAJ_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_MPC_AVOIDOBS_CTRAJ_POSTER_STR ( FILE *in, FILE *out,
       struct MPC_AVOIDOBS_CTRAJ_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_MPC_AVOIDOBS_MODE_POSTER_STR ( FILE *in, FILE *out,
       struct MPC_AVOIDOBS_MODE_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_MPC_AVOID_STR ( FILE *in, FILE *out,
       struct MPC_AVOID_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_VELFEEDBACKMODE_I ( FILE *in, FILE *out,
       struct VELFEEDBACKMODE_I *x, int indent, int nDim, int *dims );
extern int scan_struct_DISTMAPOPTIONS_I ( FILE *in, FILE *out,
       struct DISTMAPOPTIONS_I *x, int indent, int nDim, int *dims );
extern int scan_struct_FOLLOWTRAJ_I ( FILE *in, FILE *out,
       struct FOLLOWTRAJ_I *x, int indent, int nDim, int *dims );
extern int scan_struct_TFPARAMS_I ( FILE *in, FILE *out,
       struct TFPARAMS_I *x, int indent, int nDim, int *dims );
extern int scan_struct_KEEP_SHIFT_I ( FILE *in, FILE *out,
       struct KEEP_SHIFT_I *x, int indent, int nDim, int *dims );
extern int scan_struct_ATGPARAMS_I ( FILE *in, FILE *out,
       struct ATGPARAMS_I *x, int indent, int nDim, int *dims );
extern int scan_struct_AVOIDTF_I ( FILE *in, FILE *out,
       struct AVOIDTF_I *x, int indent, int nDim, int *dims );
extern int scan_struct_ATFPARAMS_I ( FILE *in, FILE *out,
       struct ATFPARAMS_I *x, int indent, int nDim, int *dims );
extern int scan_struct_TRACK_I ( FILE *in, FILE *out,
       struct TRACK_I *x, int indent, int nDim, int *dims );
extern int scan_struct_OA_MANATRAJSEL_OPTIONS_I ( FILE *in, FILE *out,
       struct OA_MANATRAJSEL_OPTIONS_I *x, int indent, int nDim, int *dims );
extern int scan_struct_OA_TRAJSEL_OPTIONS_I ( FILE *in, FILE *out,
       struct OA_TRAJSEL_OPTIONS_I *x, int indent, int nDim, int *dims );
extern int scan_struct_OA_SETMANASYS_I ( FILE *in, FILE *out,
       struct OA_SETMANASYS_I *x, int indent, int nDim, int *dims );
extern int scan_struct_TRAJSEL_I ( FILE *in, FILE *out,
       struct TRAJSEL_I *x, int indent, int nDim, int *dims );
extern int scan_struct_OA_GOTO_INIT_I ( FILE *in, FILE *out,
       struct OA_GOTO_INIT_I *x, int indent, int nDim, int *dims );
extern int scan_struct_OA_INIT_I ( FILE *in, FILE *out,
       struct OA_INIT_I *x, int indent, int nDim, int *dims );
extern int scan_struct_LIST_WP ( FILE *in, FILE *out,
       struct LIST_WP *x, int indent, int nDim, int *dims );
extern int scan_struct_WP2D ( FILE *in, FILE *out,
       struct WP2D *x, int indent, int nDim, int *dims );
extern int scan_struct_TAB_CAND_PATH ( FILE *in, FILE *out,
       struct TAB_CAND_PATH *x, int indent, int nDim, int *dims );
extern int scan_struct_CAND_PATH_XY ( FILE *in, FILE *out,
       struct CAND_PATH_XY *x, int indent, int nDim, int *dims );
extern int scan_struct_MANA_PSTRAJ ( FILE *in, FILE *out,
       struct MANA_PSTRAJ *x, int indent, int nDim, int *dims );
extern int scan_struct_MANA_PCTRAJ ( FILE *in, FILE *out,
       struct MANA_PCTRAJ *x, int indent, int nDim, int *dims );
extern int scan_struct_TIMEV ( FILE *in, FILE *out,
       struct TIMEV *x, int indent, int nDim, int *dims );
extern int scan_struct_POLY_MULTIITV ( FILE *in, FILE *out,
       struct POLY_MULTIITV *x, int indent, int nDim, int *dims );
extern int scan_struct_POLY_ITV ( FILE *in, FILE *out,
       struct POLY_ITV *x, int indent, int nDim, int *dims );
extern int scan_struct_ITV ( FILE *in, FILE *out,
       struct ITV *x, int indent, int nDim, int *dims );
extern int scan_struct_POLYNOME4 ( FILE *in, FILE *out,
       struct POLYNOME4 *x, int indent, int nDim, int *dims );
extern int scan_enum_GPSNovatel_FLAG ( FILE *in, FILE *out,
       enum GPSNovatel_FLAG *x, int indent, int nDim, int *dims );
extern int scan_enum_GPS_LOG_FORMAT ( FILE *in, FILE *out,
       enum GPS_LOG_FORMAT *x, int indent, int nDim, int *dims );
extern int scan_struct_HEADINGb_LOG ( FILE *in, FILE *out,
       struct HEADINGb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_OEM6HEADINGb_LOG ( FILE *in, FILE *out,
       struct OEM6HEADINGb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_BESTXYZb_LOG ( FILE *in, FILE *out,
       struct BESTXYZb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_OEM4BESTXYZb_LOG ( FILE *in, FILE *out,
       struct OEM4BESTXYZb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_BESTVELb_LOG ( FILE *in, FILE *out,
       struct BESTVELb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_OEM4BESTVELb_LOG ( FILE *in, FILE *out,
       struct OEM4BESTVELb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_BESTUTMb_LOG ( FILE *in, FILE *out,
       struct BESTUTMb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_OEM4BESTUTMb_LOG ( FILE *in, FILE *out,
       struct OEM4BESTUTMb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_BESTPOSb_LOG ( FILE *in, FILE *out,
       struct BESTPOSb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_OEM4BESTPOSb_LOG ( FILE *in, FILE *out,
       struct OEM4BESTPOSb_LOG *x, int indent, int nDim, int *dims );
extern int scan_struct_OEM4_BINARY_HEADER ( FILE *in, FILE *out,
       struct OEM4_BINARY_HEADER *x, int indent, int nDim, int *dims );

/* ======================== SCAN DES TYPEDEF ============================= */

extern int scan_OEM4_BINARY_HEADER ( FILE *in, FILE *out,
       OEM4_BINARY_HEADER *x, int indent, int nDim, int *dims );
extern int scan_OEM4BESTPOSb_LOG ( FILE *in, FILE *out,
       OEM4BESTPOSb_LOG *x, int indent, int nDim, int *dims );
extern int scan_BESTPOSb_LOG ( FILE *in, FILE *out,
       BESTPOSb_LOG *x, int indent, int nDim, int *dims );
extern int scan_OEM4BESTUTMb_LOG ( FILE *in, FILE *out,
       OEM4BESTUTMb_LOG *x, int indent, int nDim, int *dims );
extern int scan_BESTUTMb_LOG ( FILE *in, FILE *out,
       BESTUTMb_LOG *x, int indent, int nDim, int *dims );
extern int scan_OEM4BESTVELb_LOG ( FILE *in, FILE *out,
       OEM4BESTVELb_LOG *x, int indent, int nDim, int *dims );
extern int scan_BESTVELb_LOG ( FILE *in, FILE *out,
       BESTVELb_LOG *x, int indent, int nDim, int *dims );
extern int scan_OEM4BESTXYZb_LOG ( FILE *in, FILE *out,
       OEM4BESTXYZb_LOG *x, int indent, int nDim, int *dims );
extern int scan_BESTXYZb_LOG ( FILE *in, FILE *out,
       BESTXYZb_LOG *x, int indent, int nDim, int *dims );
extern int scan_OEM6HEADINGb_LOG ( FILE *in, FILE *out,
       OEM6HEADINGb_LOG *x, int indent, int nDim, int *dims );
extern int scan_HEADINGb_LOG ( FILE *in, FILE *out,
       HEADINGb_LOG *x, int indent, int nDim, int *dims );
extern int scan_GPS_LOG_FORMAT ( FILE *in, FILE *out,
       GPS_LOG_FORMAT *x, int indent, int nDim, int *dims );
extern int scan_GPSNovatel_FLAG ( FILE *in, FILE *out,
       GPSNovatel_FLAG *x, int indent, int nDim, int *dims );
extern int scan_POLYNOME4 ( FILE *in, FILE *out,
       POLYNOME4 *x, int indent, int nDim, int *dims );
extern int scan_ITV ( FILE *in, FILE *out,
       ITV *x, int indent, int nDim, int *dims );
extern int scan_POLY_ITV ( FILE *in, FILE *out,
       POLY_ITV *x, int indent, int nDim, int *dims );
extern int scan_POLY_MULTIITV ( FILE *in, FILE *out,
       POLY_MULTIITV *x, int indent, int nDim, int *dims );
extern int scan_TIMEV ( FILE *in, FILE *out,
       TIMEV *x, int indent, int nDim, int *dims );
extern int scan_MANA_PCTRAJ ( FILE *in, FILE *out,
       MANA_PCTRAJ *x, int indent, int nDim, int *dims );
extern int scan_MANA_PSTRAJ ( FILE *in, FILE *out,
       MANA_PSTRAJ *x, int indent, int nDim, int *dims );
extern int scan_CAND_PATH_XY ( FILE *in, FILE *out,
       CAND_PATH_XY *x, int indent, int nDim, int *dims );
extern int scan_TAB_CAND_PATH ( FILE *in, FILE *out,
       TAB_CAND_PATH *x, int indent, int nDim, int *dims );
extern int scan_WP2D ( FILE *in, FILE *out,
       WP2D *x, int indent, int nDim, int *dims );
extern int scan_LIST_WP ( FILE *in, FILE *out,
       LIST_WP *x, int indent, int nDim, int *dims );
extern int scan_OA_INIT_I ( FILE *in, FILE *out,
       OA_INIT_I *x, int indent, int nDim, int *dims );
extern int scan_OA_GOTO_INIT_I ( FILE *in, FILE *out,
       OA_GOTO_INIT_I *x, int indent, int nDim, int *dims );
extern int scan_TRAJSEL_I ( FILE *in, FILE *out,
       TRAJSEL_I *x, int indent, int nDim, int *dims );
extern int scan_OA_SETMANASYS_I ( FILE *in, FILE *out,
       OA_SETMANASYS_I *x, int indent, int nDim, int *dims );
extern int scan_OA_TRAJSEL_OPTIONS_I ( FILE *in, FILE *out,
       OA_TRAJSEL_OPTIONS_I *x, int indent, int nDim, int *dims );
extern int scan_OA_MANATRAJSEL_OPTIONS_I ( FILE *in, FILE *out,
       OA_MANATRAJSEL_OPTIONS_I *x, int indent, int nDim, int *dims );
extern int scan_TRACK_I ( FILE *in, FILE *out,
       TRACK_I *x, int indent, int nDim, int *dims );
extern int scan_ATFPARAMS_I ( FILE *in, FILE *out,
       ATFPARAMS_I *x, int indent, int nDim, int *dims );
extern int scan_AVOIDTF_I ( FILE *in, FILE *out,
       AVOIDTF_I *x, int indent, int nDim, int *dims );
extern int scan_ROBUFAST_COM_PARAMS_I ( FILE *in, FILE *out,
       ROBUFAST_COM_PARAMS_I *x, int indent, int nDim, int *dims );
extern int scan_KEEP_SHIFT_I ( FILE *in, FILE *out,
       KEEP_SHIFT_I *x, int indent, int nDim, int *dims );
extern int scan_TFPARAMS_I ( FILE *in, FILE *out,
       TFPARAMS_I *x, int indent, int nDim, int *dims );
extern int scan_FOLLOWTRAJ_I ( FILE *in, FILE *out,
       FOLLOWTRAJ_I *x, int indent, int nDim, int *dims );
extern int scan_DISTMAPOPTIONS_I ( FILE *in, FILE *out,
       DISTMAPOPTIONS_I *x, int indent, int nDim, int *dims );
extern int scan_VELFEEDBACKMODE_I ( FILE *in, FILE *out,
       VELFEEDBACKMODE_I *x, int indent, int nDim, int *dims );
extern int scan_MPC_AVOID_STR ( FILE *in, FILE *out,
       MPC_AVOID_STR *x, int indent, int nDim, int *dims );
extern int scan_MPC_AVOIDOBS_MODE_POSTER_STR ( FILE *in, FILE *out,
       MPC_AVOIDOBS_MODE_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_MPC_AVOIDOBS_CTRAJ_POSTER_STR ( FILE *in, FILE *out,
       MPC_AVOIDOBS_CTRAJ_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_MPC_AVOIDOBS_STRAJ_POSTER_STR ( FILE *in, FILE *out,
       MPC_AVOIDOBS_STRAJ_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_MPC_AVOIDOBS_BESTPATHTS_POSTER_STR ( FILE *in, FILE *out,
       MPC_AVOIDOBS_BESTPATHTS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_MPC_AVOIDOBS_CANDPATHTS_POSTER_STR ( FILE *in, FILE *out,
       MPC_AVOIDOBS_CANDPATHTS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR ( FILE *in, FILE *out,
       MPC_AVOIDOBS_ATFWAYPOINTS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR ( FILE *in, FILE *out,
       MPC_AVOIDOBS_DISTOBSMAP_POSTER_STR *x, int indent, int nDim, int *dims );
#ifdef __cplusplus
}
#endif

#endif /* MPC_AVOIDOBS_SCAN_H */

