
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

/* 
 * MPC_avoidObsType.h:     La SDI_F de MPC_avoidObs
 *
 * Utilise par le module et par les clients
 * (inclut dans MPC_avoidObsMsgLib.h et MPC_avoidObsPosterLib.h)
 * 
 */

#ifndef MPC_avoidObs_TYPE_H
#define MPC_avoidObs_TYPE_H

#include "genom/modules.h"
#include "MPC_avoidObsError.h"

/* Nombre de tache d'execution de ce module */
#define MPC_AVOIDOBS_NB_EXEC_TASK                   (1)


#endif
#ifndef MPC_avoidObs_TYPE1_H
#define MPC_avoidObs_TYPE1_H

#include "/opt/openrobots/include/genPos/genPosStruct.h"
#include "/opt/openrobots/include/pom/pomStruct.h"
#include "/opt/openrobots/include/dtm/dtmStruct.h"
#include "/opt/openrobots/include/MPC_DEMTreatment/MPC_DEMTreatment-Struct.h"
#include "/opt/openrobots/include/MPC/gen-structs/structs_gen.h"
#include "/opt/openrobots/include/MPC_planner/MPC_planner-Struct.h"
#include "/opt/openrobots/include/GPSNovatel/msgStruct.h"
#include "/opt/openrobots/include/GPSNovatel/logDataStruct.h"
#include "MPC_avoidObs-Struct.h"

/*
 * Structure de donnees interne
 */
typedef struct MPC_AVOID_STR {
	int system_type;
	GENPOS_CART_CONFIG goal_pos;
	int mode;
	MANA_PCTRAJ ctraj;
	MANA_PSTRAJ straj;
	LIST_WP listWP;
	float maxDistTgtReached;
	float maxDistWpReached;
	float maxAngleWpReached;
	int vel_fb_mode;
	int GoTo_fixFinalTH;
	int ctrl_poster_found;
	int gps_poster_found;
	int distmap_poster_found;
	int straj_poster_found;
	int atg_server_port;
	float dt_latShift;
	float SlopeMapDist;
	float MaxSlope;
	float MaxVarSlope;
	float SafeDist;
	int stop_before_col;
	OA_INIT_I Init_I;
	TRAJSEL_I Goto_I;
	OA_SETMANASYS_I SetManaSys_I;
	OA_TRAJSEL_OPTIONS_I OA_TrajSel_Options_I;
	OA_MANATRAJSEL_OPTIONS_I OA_ManaTrajSel_Options_I;
	WP2D AddWayPoint_I;
	TRACK_I Track_I;
	OA_GOTO_INIT_I OA_GoTo_Init_I;
	AVOIDTF_I AvoidTF_I;
	ROBUFAST_COM_PARAMS_I RobufastComParams_I;
	VELFEEDBACKMODE_I vel_feedback_I;
	KEEP_SHIFT_I Keep_shift_I;
	FOLLOWTRAJ_I FollowTraj_I;
	float TimeHorizon_I;
	DISTMAPOPTIONS_I DistMapOptions_I;
	TFPARAMS_I TFParams_I;
	ATFPARAMS_I ATFParams_I;
	int display_time;
	int FILL_DISPLAY_POSTERS;
	GEN_PATH_XY bestPath;
} MPC_AVOID_STR;


#endif

