
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef MPC_avoidObs_TCLSERV_CLIENT_ERROR_H
#define MPC_avoidObs_TCLSERV_CLIENT_ERROR_H

#include <server/MPC_avoidObsError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum MPC_avoidObs_error {
	E_MPC_avoidObs_OK					  			= 0,

	/* module errors */
	E_MPC_avoidObs_UNVALID_PARAMETERS             = S_MPC_avoidObs_UNVALID_PARAMETERS,
	E_MPC_avoidObs_DISTMAP_NOT_FOUND              = S_MPC_avoidObs_DISTMAP_NOT_FOUND,
	E_MPC_avoidObs_STRAJ_NOT_FOUND                = S_MPC_avoidObs_STRAJ_NOT_FOUND,
	E_MPC_avoidObs_POM_NOT_FOUND                  = S_MPC_avoidObs_POM_NOT_FOUND,
	E_MPC_avoidObs_PATH_POSTER_READ               = S_MPC_avoidObs_PATH_POSTER_READ,
	E_MPC_avoidObs_SYS_UNDEFINED                  = S_MPC_avoidObs_SYS_UNDEFINED,
	E_MPC_avoidObs_DEM_POSTER_READ                = S_MPC_avoidObs_DEM_POSTER_READ,
	E_MPC_avoidObs_POM_POSTER_READ                = S_MPC_avoidObs_POM_POSTER_READ,
	E_MPC_avoidObs_NO_TRAJ                        = S_MPC_avoidObs_NO_TRAJ,
	E_MPC_avoidObs_POSTER_READ                    = S_MPC_avoidObs_POSTER_READ,
	E_MPC_avoidObs_BLOCKED                        = S_MPC_avoidObs_BLOCKED,
	E_MPC_avoidObs_NO_PATH                        = S_MPC_avoidObs_NO_PATH,
	E_MPC_avoidObs_POSTER_NOT_FOUND               = S_MPC_avoidObs_POSTER_NOT_FOUND,


	/* std errors */
	E_MPC_avoidObs_ACTIVITY_INTERRUPTED           = S_MPC_avoidObs_stdGenoM_ACTIVITY_INTERRUPTED,
	E_MPC_avoidObs_TOO_MANY_ACTIVITIES            = S_MPC_avoidObs_stdGenoM_TOO_MANY_ACTIVITIES,
	E_MPC_avoidObs_ACTIVITY_FAILED                = S_MPC_avoidObs_stdGenoM_ACTIVITY_FAILED,
	E_MPC_avoidObs_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_MPC_avoidObs_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_MPC_avoidObs_UNKNOWN_ACTIVITY               = S_MPC_avoidObs_stdGenoM_UNKNOWN_ACTIVITY,
	E_MPC_avoidObs_FORBIDDEN_ACTIVITY_TRANSITION  = S_MPC_avoidObs_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_MPC_avoidObs_SYSTEM_ERROR                   = S_MPC_avoidObs_stdGenoM_SYSTEM_ERROR,
	E_MPC_avoidObs_ACTIVITY_ALREADY_ENDED         = S_MPC_avoidObs_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_MPC_avoidObs_WAIT_INIT_RQST                 = S_MPC_avoidObs_stdGenoM_WAIT_INIT_RQST,
	E_MPC_avoidObs_CONTROL_CODEL_ERROR            = S_MPC_avoidObs_stdGenoM_CONTROL_CODEL_ERROR,
	E_MPC_avoidObs_EXEC_TASK_SUSPENDED            = S_MPC_avoidObs_stdGenoM_EXEC_TASK_SUSPENDED,
	E_MPC_avoidObs_BAD_BLOCK_TYPE                 = S_MPC_avoidObs_stdGenoM_BAD_BLOCK_TYPE,
	E_MPC_avoidObs_BAD_POSTER_TYPE                = S_MPC_avoidObs_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum MPC_avoidObs_error MPC_avoidObs_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int MPC_avoidObs_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the MPC_avoidObs context.
 *
 * Returns NULL in case of failure
 */
const char* MPC_avoidObs_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
