
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_avoidObs_TCLSERV_CLIENT_MSG_LIB_H
#define MPC_avoidObs_TCLSERV_CLIENT_MSG_LIB_H

#include <server/MPC_avoidObsType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int MPC_avoidObsTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int MPC_avoidObsTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int MPC_avoidObsTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 OA_INIT_I *(in_Init_I) 
		);

int MPC_avoidObsTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				OA_INIT_I *(in_Init_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					OA_INIT_I *(in_Init_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientSetManaSysRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 OA_SETMANASYS_I *(in_SetManaSys_I) 
		);

int MPC_avoidObsTclservClientSetManaSysReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientSetManaSysRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				OA_SETMANASYS_I *(in_SetManaSys_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientSetManaSysRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					OA_SETMANASYS_I *(in_SetManaSys_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientSetGoToOptionsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 OA_GOTO_INIT_I *(in_OA_GoTo_Init_I)
		);

int MPC_avoidObsTclservClientSetGoToOptionsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientSetGoToOptionsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 OA_GOTO_INIT_I *(in_OA_GoTo_Init_I) ,
				 
				 int *bilan);




int MPC_avoidObsTclservClientSimpleGoToRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 TRAJSEL_I *(in_Goto_I) 
		);

int MPC_avoidObsTclservClientSimpleGoToReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientSimpleGoToRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				TRAJSEL_I *(in_Goto_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientSimpleGoToRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					TRAJSEL_I *(in_Goto_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientSetTrajSelOptionsRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 OA_TRAJSEL_OPTIONS_I *(in_OA_TrajSel_Options_I) 
		);

int MPC_avoidObsTclservClientSetTrajSelOptionsReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientSetTrajSelOptionsRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				OA_TRAJSEL_OPTIONS_I *(in_OA_TrajSel_Options_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientSetTrajSelOptionsRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					OA_TRAJSEL_OPTIONS_I *(in_OA_TrajSel_Options_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientSetManaTrajSelOptionsRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 OA_MANATRAJSEL_OPTIONS_I *(in_OA_ManaTrajSel_Options_I) 
		);

int MPC_avoidObsTclservClientSetManaTrajSelOptionsReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientSetManaTrajSelOptionsRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				OA_MANATRAJSEL_OPTIONS_I *(in_OA_ManaTrajSel_Options_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientSetManaTrajSelOptionsRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					OA_MANATRAJSEL_OPTIONS_I *(in_OA_ManaTrajSel_Options_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientTrajSelToRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 TRAJSEL_I *(in_Goto_I) 
		);

int MPC_avoidObsTclservClientTrajSelToReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientTrajSelToRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				TRAJSEL_I *(in_Goto_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientTrajSelToRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					TRAJSEL_I *(in_Goto_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientAddWayPointRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 WP2D *(in_AddWayPoint_I)
		);

int MPC_avoidObsTclservClientAddWayPointReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientAddWayPointRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 WP2D *(in_AddWayPoint_I) ,
				 
				 int *bilan);




int MPC_avoidObsTclservClientTrackRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 TRACK_I *(in_Track_I) 
		);

int MPC_avoidObsTclservClientTrackReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientTrackRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				TRACK_I *(in_Track_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientTrackRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					TRACK_I *(in_Track_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int MPC_avoidObsTclservClientStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int MPC_avoidObsTclservClientSetATFParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 ATFPARAMS_I *(in_ATFParams_I)
		);

int MPC_avoidObsTclservClientSetATFParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientSetATFParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 ATFPARAMS_I *(in_ATFParams_I) ,
				 
				 int *bilan);




int MPC_avoidObsTclservClientAvoidTFRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 AVOIDTF_I *(in_AvoidTF_I) 
		);

int MPC_avoidObsTclservClientAvoidTFReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientAvoidTFRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				AVOIDTF_I *(in_AvoidTF_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientAvoidTFRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					AVOIDTF_I *(in_AvoidTF_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientKeepLatShiftRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 KEEP_SHIFT_I *(in_Keep_shift_I) 
		);

int MPC_avoidObsTclservClientKeepLatShiftReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientKeepLatShiftRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				KEEP_SHIFT_I *(in_Keep_shift_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientKeepLatShiftRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					KEEP_SHIFT_I *(in_Keep_shift_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientSetRobufastComParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 ROBUFAST_COM_PARAMS_I *(in_RobufastComParams_I)
		);

int MPC_avoidObsTclservClientSetRobufastComParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientSetRobufastComParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 ROBUFAST_COM_PARAMS_I *(in_RobufastComParams_I) ,
				 
				 int *bilan);




int MPC_avoidObsTclservClientStartATG_tcp_serverRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int MPC_avoidObsTclservClientStartATG_tcp_serverReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientStartATG_tcp_serverRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int MPC_avoidObsTclservClientStartATG_tcp_serverRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int MPC_avoidObsTclservClientStopATG_tcp_serverRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int MPC_avoidObsTclservClientStopATG_tcp_serverReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientStopATG_tcp_serverRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int MPC_avoidObsTclservClientStopATG_tcp_serverRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int MPC_avoidObsTclservClientSetVelFeedbackModeRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 VELFEEDBACKMODE_I *(in_vel_feedback_I)
		);

int MPC_avoidObsTclservClientSetVelFeedbackModeReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientSetVelFeedbackModeRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 VELFEEDBACKMODE_I *(in_vel_feedback_I) ,
				 
				 int *bilan);




int MPC_avoidObsTclservClientSetTFParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 TFPARAMS_I *(in_TFParams_I)
		);

int MPC_avoidObsTclservClientSetTFParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientSetTFParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 TFPARAMS_I *(in_TFParams_I) ,
				 
				 int *bilan);




int MPC_avoidObsTclservClientFollowTrajRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 FOLLOWTRAJ_I *(in_FollowTraj_I) 
		);

int MPC_avoidObsTclservClientFollowTrajReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_avoidObsTclservClientFollowTrajRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				FOLLOWTRAJ_I *(in_FollowTraj_I) ,
				
				int *bilan);

int MPC_avoidObsTclservClientFollowTrajRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					FOLLOWTRAJ_I *(in_FollowTraj_I) ,
					
					int *bilan);




int MPC_avoidObsTclservClientSetDistMapOptionsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 DISTMAPOPTIONS_I *(in_DistMapOptions_I)
		);

int MPC_avoidObsTclservClientSetDistMapOptionsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientSetDistMapOptionsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 DISTMAPOPTIONS_I *(in_DistMapOptions_I) ,
				 
				 int *bilan);




int MPC_avoidObsTclservClientSetDisplayPostersOptionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 int *(in_FILL_DISPLAY_POSTERS)
		);

int MPC_avoidObsTclservClientSetDisplayPostersOptionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientSetDisplayPostersOptionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 int *(in_FILL_DISPLAY_POSTERS) ,
				 
				 int *bilan);




int MPC_avoidObsTclservClientSetDisplayTimerOptionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 int *(in_display_time)
		);

int MPC_avoidObsTclservClientSetDisplayTimerOptionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_avoidObsTclservClientSetDisplayTimerOptionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 int *(in_display_time) ,
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* MPC_avoidObsTCLSERV_CLIENT_MSG_LIB_H */

