
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] MPC_avoidObsInstall] >= 0 } {
    interp expose {} MPC_avoidObsInstall
}

proc ::MPC_avoidObsInstall { name } {
    foreach rqst { "Init" "SetManaSys" "SetGoToOptions" "SimpleGoTo" "SetTrajSelOptions" "SetManaTrajSelOptions" "TrajSelTo" "AddWayPoint" "Track" "Stop" "SetATFParams" "AvoidTF" "KeepLatShift" "SetRobufastComParams" "StartATG_tcp_server" "StopATG_tcp_server" "SetVelFeedbackMode" "SetTFParams" "FollowTraj" "SetDistMapOptions" "SetDisplayPostersOption" "SetDisplayTimerOption" "ModemodePosterRead" "CTrajctrajPosterRead" "STrajstrajPosterRead" "BestPathTSbestPathPosterRead" "CandPathTStabCandPath_userPosterRead" "ATFwaypointsatf_waypoints_userPosterRead" "DistObsMapdistObsMap_userPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} MPC_avoidObs$rqst $name
    }
}

interp hide {} MPC_avoidObsInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsInit] >= 0 } {
    interp expose {} MPC_avoidObsInit
}
if { [lsearch [interp hidden] MPC_avoidObsInitFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsInitFormatOutput
}

proc ::MPC_avoidObsInit { name args } {
    set format {}
    lappend format [list string "Init_I.pomPoster" "" ]
    lappend format [list string "Init_I.demPoster" "" ]
    lappend format [list string "Init_I.ctrlPoster" "" ]
    lappend format [list string "Init_I.distmapPoster" "" ]
    lappend format [list string "Init_I.gpsPoster" "" ]
    lappend format [list string "Init_I.strajPoster" "" ]
    lappend format [list float "Init_I.AO_MAX_DIST_TGT_REACHED" 0.0 ]
    lappend format [list int "Init_I.stop_before_col" 0 ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Initializes the MPC obstacle avoidance module" \
	"OA_INIT_I\n| char pomPoster\[256\]\n| char demPoster\[256\]\n| char ctrlPoster\[256\]\n| char distmapPoster\[256\]\n| char gpsPoster\[256\]\n| char strajPoster\[256\]\n| float AO_MAX_DIST_TGT_REACHED\n| int stop_before_col\n" \
	8 \
	$format \
	$args ]
}


proc ::MPC_avoidObsInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsInit
interp hide {} MPC_avoidObsInitFormatOutput





# SetManaSys ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetManaSys] >= 0 } {
    interp expose {} MPC_avoidObsSetManaSys
}
if { [lsearch [interp hidden] MPC_avoidObsSetManaSysFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetManaSysFormatOutput
}

proc ::MPC_avoidObsSetManaSys { name args } {
    set format {}
    lappend format [list double "SetManaSys_I.body_length" 0.0 ]
    lappend format [list double "SetManaSys_I.body_width" 0.0 ]
    lappend format [list double "SetManaSys_I.body_z" 0.0 ]
    lappend format [list double "SetManaSys_I.ground_clearance" 0.0 ]
    lappend format [list double "SetManaSys_I.rollMax" 0.0 ]
    lappend format [list double "SetManaSys_I.pitchMax" 0.0 ]
    lappend format [list double "SetManaSys_I.vmin" 0.0 ]
    lappend format [list double "SetManaSys_I.vmax" 0.0 ]
    lappend format [list double "SetManaSys_I.accel" 0.0 ]
    lappend format [list double "SetManaSys_I.decel" 0.0 ]
    lappend format [list double "SetManaSys_I.wmax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetManaSys" \
	"Change Mana geometry and system constraints" \
	"OA_SETMANASYS_I\n| double body_length\n| double body_width\n| double body_z\n| double ground_clearance\n| double rollMax\n| double pitchMax\n| double vmin\n| double vmax\n| double accel\n| double decel\n| double wmax\n" \
	11 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetManaSysFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetManaSys
interp hide {} MPC_avoidObsSetManaSysFormatOutput





# SetGoToOptions ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetGoToOptions] >= 0 } {
    interp expose {} MPC_avoidObsSetGoToOptions
}
if { [lsearch [interp hidden] MPC_avoidObsSetGoToOptionsFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetGoToOptionsFormatOutput
}

proc ::MPC_avoidObsSetGoToOptions { name args } {
    set format {}
    lappend format [list float "Maximal distance to consider the target position as reached" 0.500000 ]
    lappend format [list float "OA_GoTo_Init_I.maxDistWpReached" 0.0 ]
    lappend format [list float "OA_GoTo_Init_I.maxAngleWpReached" 0.0 ]
    lappend format [list int "OA_GoTo_Init_I.fixFinalTH" 0 ]

    return [ ::cs::rqstSend "${name}" "SetGoToOptions" \
	"Set the standard GoTo options" \
	"OA_GOTO_INIT_I\n| float maxDistTgtReached\n| float maxDistWpReached\n| float maxAngleWpReached\n| int fixFinalTH\n" \
	4 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetGoToOptionsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetGoToOptions
interp hide {} MPC_avoidObsSetGoToOptionsFormatOutput





# SimpleGoTo ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSimpleGoTo] >= 0 } {
    interp expose {} MPC_avoidObsSimpleGoTo
}
if { [lsearch [interp hidden] MPC_avoidObsSimpleGoToFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSimpleGoToFormatOutput
}

proc ::MPC_avoidObsSimpleGoTo { name args } {
    set format {}
    lappend format [list double "X coordinate" 0.000000 ]
    lappend format [list double "Y coordinate" 0.000000 ]
    lappend format [list double "Goto_I.goal.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SimpleGoTo" \
	"Goto process without obstacle avoidance" \
	"TRAJSEL_I\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n" \
	3 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSimpleGoToFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSimpleGoTo
interp hide {} MPC_avoidObsSimpleGoToFormatOutput





# SetTrajSelOptions ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetTrajSelOptions] >= 0 } {
    interp expose {} MPC_avoidObsSetTrajSelOptions
}
if { [lsearch [interp hidden] MPC_avoidObsSetTrajSelOptionsFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetTrajSelOptionsFormatOutput
}

proc ::MPC_avoidObsSetTrajSelOptions { name args } {
    set format {}
    lappend format [list double "OA_TrajSel_Options_I.AO_MAX_DIST_TGT_REACHED" 0.0 ]
    lappend format [list double "OA_TrajSel_Options_I.AO_MAX_DIST_WP_REACHED" 0.0 ]
    lappend format [list double "OA_TrajSel_Options_I.AO_MAX_ANGLE_WP_REACHED" 0.0 ]
    lappend format [list double "OA_TrajSel_Options_I.AO_SLOPEMAP_DIST" 0.0 ]
    lappend format [list double "OA_TrajSel_Options_I.AO_MAX_SLOPE" 0.0 ]
    lappend format [list double "OA_TrajSel_Options_I.AO_MAX_VAR_SLOPE" 0.0 ]
    lappend format [list double "OA_TrajSel_Options_I.AO_SAFE_DIST" 0.0 ]
    lappend format [list double "OA_TrajSel_Options_I.AO_TIME_TRAJ" 0.0 ]
    lappend format [list double "OA_TrajSel_Options_I.AO_TIME_TRAJ_OBS_FREE" 0.0 ]
    lappend format [list double "OA_TrajSel_Options_I.AO_DIST_OBS_MAX" 0.0 ]
    lappend format [list int "OA_TrajSel_Options_I.AO_SAMPLING_CAND_TRAJ" 0 ]

    return [ ::cs::rqstSend "${name}" "SetTrajSelOptions" \
	"Change trajectory selection options" \
	"OA_TRAJSEL_OPTIONS_I\n| double AO_MAX_DIST_TGT_REACHED\n| double AO_MAX_DIST_WP_REACHED\n| double AO_MAX_ANGLE_WP_REACHED\n| double AO_SLOPEMAP_DIST\n| double AO_MAX_SLOPE\n| double AO_MAX_VAR_SLOPE\n| double AO_SAFE_DIST\n| double AO_TIME_TRAJ\n| double AO_TIME_TRAJ_OBS_FREE\n| double AO_DIST_OBS_MAX\n| int AO_SAMPLING_CAND_TRAJ\n" \
	11 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetTrajSelOptionsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetTrajSelOptions
interp hide {} MPC_avoidObsSetTrajSelOptionsFormatOutput





# SetManaTrajSelOptions ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetManaTrajSelOptions] >= 0 } {
    interp expose {} MPC_avoidObsSetManaTrajSelOptions
}
if { [lsearch [interp hidden] MPC_avoidObsSetManaTrajSelOptionsFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetManaTrajSelOptionsFormatOutput
}

proc ::MPC_avoidObsSetManaTrajSelOptions { name args } {
    set format {}
    lappend format [list float "OA_ManaTrajSel_Options_I.AO_WG" 0.0 ]
    lappend format [list float "OA_ManaTrajSel_Options_I.AO_WO" 0.0 ]
    lappend format [list float "OA_ManaTrajSel_Options_I.AO_WH" 0.0 ]
    lappend format [list float "OA_ManaTrajSel_Options_I.COEF_ACC" 0.0 ]
    lappend format [list float "OA_ManaTrajSel_Options_I.COEF_AACC" 0.0 ]
    lappend format [list float "OA_ManaTrajSel_Options_I.COEF_JERK" 0.0 ]
    lappend format [list float "OA_ManaTrajSel_Options_I.COEF_AJERK" 0.0 ]
    lappend format [list int "OA_ManaTrajSel_Options_I.ManaTrajSel_spg_acc" 0 ]
    lappend format [list int "OA_ManaTrajSel_Options_I.ManaTrajSel_spg_aacc" 0 ]
    lappend format [list int "OA_ManaTrajSel_Options_I.ManaTrajSel_spg_jerk" 0 ]
    lappend format [list int "OA_ManaTrajSel_Options_I.ManaTrajSel_spg_ajerk" 0 ]

    return [ ::cs::rqstSend "${name}" "SetManaTrajSelOptions" \
	"Change Mana trajectory selection options" \
	"OA_MANATRAJSEL_OPTIONS_I\n| float AO_WG\n| float AO_WO\n| float AO_WH\n| float COEF_ACC\n| float COEF_AACC\n| float COEF_JERK\n| float COEF_AJERK\n| int ManaTrajSel_spg_acc\n| int ManaTrajSel_spg_aacc\n| int ManaTrajSel_spg_jerk\n| int ManaTrajSel_spg_ajerk\n" \
	11 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetManaTrajSelOptionsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetManaTrajSelOptions
interp hide {} MPC_avoidObsSetManaTrajSelOptionsFormatOutput





# TrajSelTo ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsTrajSelTo] >= 0 } {
    interp expose {} MPC_avoidObsTrajSelTo
}
if { [lsearch [interp hidden] MPC_avoidObsTrajSelToFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsTrajSelToFormatOutput
}

proc ::MPC_avoidObsTrajSelTo { name args } {
    set format {}
    lappend format [list double "X coordinate" 0.000000 ]
    lappend format [list double "Y coordinate" 0.000000 ]
    lappend format [list double "Goto_I.goal.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "TrajSelTo" \
	"Obstacle avoidance process by trajectory selection" \
	"TRAJSEL_I\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n" \
	3 \
	$format \
	$args ]
}


proc ::MPC_avoidObsTrajSelToFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsTrajSelTo
interp hide {} MPC_avoidObsTrajSelToFormatOutput





# AddWayPoint ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsAddWayPoint] >= 0 } {
    interp expose {} MPC_avoidObsAddWayPoint
}
if { [lsearch [interp hidden] MPC_avoidObsAddWayPointFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsAddWayPointFormatOutput
}

proc ::MPC_avoidObsAddWayPoint { name args } {
    set format {}
    lappend format [list float "X coordinate" 0.000000 ]
    lappend format [list float "Y coordinate" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "AddWayPoint" \
	"Add a new waypoint to reach" \
	"WP2D\n| float x\n| float y\n" \
	2 \
	$format \
	$args ]
}


proc ::MPC_avoidObsAddWayPointFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsAddWayPoint
interp hide {} MPC_avoidObsAddWayPointFormatOutput





# Track ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsTrack] >= 0 } {
    interp expose {} MPC_avoidObsTrack
}
if { [lsearch [interp hidden] MPC_avoidObsTrackFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsTrackFormatOutput
}

proc ::MPC_avoidObsTrack { name args } {
    set format {}
    lappend format [list string "Waypoints poster name" "" ]

    return [ ::cs::rqstSend "${name}" "Track" \
	"Track a GENPOS_CART_CONFIG poster, as produced from Nav for instance" \
	"TRACK_I\n| char wpPoster\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::MPC_avoidObsTrackFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsTrack
interp hide {} MPC_avoidObsTrackFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsStop] >= 0 } {
    interp expose {} MPC_avoidObsStop
}
if { [lsearch [interp hidden] MPC_avoidObsStopFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsStopFormatOutput
}

proc ::MPC_avoidObsStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stop moving the the waypoints" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_avoidObsStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsStop
interp hide {} MPC_avoidObsStopFormatOutput





# SetATFParams ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetATFParams] >= 0 } {
    interp expose {} MPC_avoidObsSetATFParams
}
if { [lsearch [interp hidden] MPC_avoidObsSetATFParamsFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetATFParamsFormatOutput
}

proc ::MPC_avoidObsSetATFParams { name args } {
    set format {}
    lappend format [list int "AvoidTF version (1 or 2)" 1 ]
    lappend format [list float "distance between two successive max dist points" 0.500000 ]
    lappend format [list int "minimal number of intervals to keep between two strangling points" 7 ]
    lappend format [list float "time coef used to select the waypoints arriving time" 1.300000 ]

    return [ ::cs::rqstSend "${name}" "SetATFParams" \
	"Set the optional traj follow with obstacle avoidance parameters" \
	"ATFPARAMS_I\n| int version\n| float ds_maxdist_points\n| int min_nbitv_trajgen\n| float coef_time\n" \
	4 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetATFParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetATFParams
interp hide {} MPC_avoidObsSetATFParamsFormatOutput





# AvoidTF ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsAvoidTF] >= 0 } {
    interp expose {} MPC_avoidObsAvoidTF
}
if { [lsearch [interp hidden] MPC_avoidObsAvoidTFFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsAvoidTFFormatOutput
}

proc ::MPC_avoidObsAvoidTF { name args } {
    set format {}
    lappend format [list string "reference path poster name" "pathPosterName" ]
    lappend format [list float "reference corridor width" 3.000000 ]
    lappend format [list float "AvoidTF_I.max_path_length" 0.0 ]
    lappend format [list int "AvoidTF_I.loop_on_traj" 0 ]

    return [ ::cs::rqstSend "${name}" "AvoidTF" \
	"Trajectory following with obstacle avoidance process" \
	"AVOIDTF_I\n| char pathPoster\[256\]\n| float width\n| float max_path_length\n| int loop_on_traj\n" \
	4 \
	$format \
	$args ]
}


proc ::MPC_avoidObsAvoidTFFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsAvoidTF
interp hide {} MPC_avoidObsAvoidTFFormatOutput





# KeepLatShift ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsKeepLatShift] >= 0 } {
    interp expose {} MPC_avoidObsKeepLatShift
}
if { [lsearch [interp hidden] MPC_avoidObsKeepLatShiftFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsKeepLatShiftFormatOutput
}

proc ::MPC_avoidObsKeepLatShift { name args } {
    set format {}
    lappend format [list float "lateral shift" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "KeepLatShift" \
	"Trajectory following with obstacle avoidance process" \
	"KEEP_SHIFT_I\n| float shift\n" \
	1 \
	$format \
	$args ]
}


proc ::MPC_avoidObsKeepLatShiftFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsKeepLatShift
interp hide {} MPC_avoidObsKeepLatShiftFormatOutput





# SetRobufastComParams ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetRobufastComParams] >= 0 } {
    interp expose {} MPC_avoidObsSetRobufastComParams
}
if { [lsearch [interp hidden] MPC_avoidObsSetRobufastComParamsFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetRobufastComParamsFormatOutput
}

proc ::MPC_avoidObsSetRobufastComParams { name args } {
    set format {}
    lappend format [list int "the socket server port" 5432 ]
    lappend format [list float "RobufastComParams_I.dt_latShift" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetRobufastComParams" \
	"Activate TCP socket server to provide the obstacle avoidance trajectories" \
	"ROBUFAST_COM_PARAMS_I\n| int port\n| float dt_latShift\n" \
	2 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetRobufastComParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetRobufastComParams
interp hide {} MPC_avoidObsSetRobufastComParamsFormatOutput





# StartATG_tcp_server ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsStartATG_tcp_server] >= 0 } {
    interp expose {} MPC_avoidObsStartATG_tcp_server
}
if { [lsearch [interp hidden] MPC_avoidObsStartATG_tcp_serverFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsStartATG_tcp_serverFormatOutput
}

proc ::MPC_avoidObsStartATG_tcp_server { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StartATG_tcp_server" \
	"Start tcp server for the AvoidTrajGen process" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_avoidObsStartATG_tcp_serverFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsStartATG_tcp_server
interp hide {} MPC_avoidObsStartATG_tcp_serverFormatOutput





# StopATG_tcp_server ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsStopATG_tcp_server] >= 0 } {
    interp expose {} MPC_avoidObsStopATG_tcp_server
}
if { [lsearch [interp hidden] MPC_avoidObsStopATG_tcp_serverFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsStopATG_tcp_serverFormatOutput
}

proc ::MPC_avoidObsStopATG_tcp_server { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopATG_tcp_server" \
	"Stop tcp server for the AvoidTrajGen process" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_avoidObsStopATG_tcp_serverFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsStopATG_tcp_server
interp hide {} MPC_avoidObsStopATG_tcp_serverFormatOutput





# SetVelFeedbackMode ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetVelFeedbackMode] >= 0 } {
    interp expose {} MPC_avoidObsSetVelFeedbackMode
}
if { [lsearch [interp hidden] MPC_avoidObsSetVelFeedbackModeFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetVelFeedbackModeFormatOutput
}

proc ::MPC_avoidObsSetVelFeedbackMode { name args } {
    set format {}
    lappend format [list string "Velocity feedback mode (sent_control or gps)" "sent_control" ]

    return [ ::cs::rqstSend "${name}" "SetVelFeedbackMode" \
	"Set the velocity feedback mode (from sent control or GPS)" \
	"VELFEEDBACKMODE_I\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetVelFeedbackModeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetVelFeedbackMode
interp hide {} MPC_avoidObsSetVelFeedbackModeFormatOutput





# SetTFParams ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetTFParams] >= 0 } {
    interp expose {} MPC_avoidObsSetTFParams
}
if { [lsearch [interp hidden] MPC_avoidObsSetTFParamsFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetTFParamsFormatOutput
}

proc ::MPC_avoidObsSetTFParams { name args } {
    set format {}
    lappend format [list float "the robot will stop under this distance to obstacles (in meters)" 0.500000 ]
    lappend format [list float "the robot's speed will be reduced under this distance to obstacles (in meters)" 5.000000 ]
    lappend format [list float "minimal coefficient used to reduce the speed of the robot (must belong to (0,1))" 0.100000 ]

    return [ ::cs::rqstSend "${name}" "SetTFParams" \
	"Set the optional traj follow parameters" \
	"TFPARAMS_I\n| float minDistToObstacles\n| float maxDistToObstacles\n| float minCoefSpeed\n" \
	3 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetTFParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetTFParams
interp hide {} MPC_avoidObsSetTFParamsFormatOutput





# FollowTraj ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsFollowTraj] >= 0 } {
    interp expose {} MPC_avoidObsFollowTraj
}
if { [lsearch [interp hidden] MPC_avoidObsFollowTrajFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsFollowTrajFormatOutput
}

proc ::MPC_avoidObsFollowTraj { name args } {
    set format {}
    lappend format [list int "mode to select the future state to reach : 1=time, 2=distance" 1 ]
    lappend format [list float "time / distance horizon of the trajectory following process" 2.000000 ]
    lappend format [list int "1 if the robot must stop before colliding with obstacle, 0 otherwise" 1 ]
    lappend format [list int "1 if the robot must loop on the followed trajectory, 0 otherwise" 0 ]

    return [ ::cs::rqstSend "${name}" "FollowTraj" \
	"Starts the trajectory following process" \
	"FOLLOWTRAJ_I\n| int horizon_mode\n| float horizon\n| int stop_before_col\n| int loop_on_traj\n" \
	4 \
	$format \
	$args ]
}


proc ::MPC_avoidObsFollowTrajFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsFollowTraj
interp hide {} MPC_avoidObsFollowTrajFormatOutput





# SetDistMapOptions ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetDistMapOptions] >= 0 } {
    interp expose {} MPC_avoidObsSetDistMapOptions
}
if { [lsearch [interp hidden] MPC_avoidObsSetDistMapOptionsFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetDistMapOptionsFormatOutput
}

proc ::MPC_avoidObsSetDistMapOptions { name args } {
    set format {}
    lappend format [list float "DistMapOptions_I.SlopeMapDist" 0.0 ]
    lappend format [list float "DistMapOptions_I.MaxSlope" 0.0 ]
    lappend format [list float "DistMapOptions_I.MaxVarSlope" 0.0 ]
    lappend format [list float "DistMapOptions_I.SafeDist" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetDistMapOptions" \
	"Set the distance to obstacles map computation options" \
	"DISTMAPOPTIONS_I\n| float SlopeMapDist\n| float MaxSlope\n| float MaxVarSlope\n| float SafeDist\n" \
	4 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetDistMapOptionsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetDistMapOptions
interp hide {} MPC_avoidObsSetDistMapOptionsFormatOutput





# SetDisplayPostersOption ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetDisplayPostersOption] >= 0 } {
    interp expose {} MPC_avoidObsSetDisplayPostersOption
}
if { [lsearch [interp hidden] MPC_avoidObsSetDisplayPostersOptionFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetDisplayPostersOptionFormatOutput
}

proc ::MPC_avoidObsSetDisplayPostersOption { name args } {
    set format {}
    lappend format [list int "FILL_DISPLAY_POSTERS" 0 ]

    return [ ::cs::rqstSend "${name}" "SetDisplayPostersOption" \
	"Set the option to fill the display posters" \
	"int FILL_DISPLAY_POSTERS\n" \
	1 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetDisplayPostersOptionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetDisplayPostersOption
interp hide {} MPC_avoidObsSetDisplayPostersOptionFormatOutput





# SetDisplayTimerOption ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSetDisplayTimerOption] >= 0 } {
    interp expose {} MPC_avoidObsSetDisplayTimerOption
}
if { [lsearch [interp hidden] MPC_avoidObsSetDisplayTimerOptionFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSetDisplayTimerOptionFormatOutput
}

proc ::MPC_avoidObsSetDisplayTimerOption { name args } {
    set format {}
    lappend format [list int "display_time" 0 ]

    return [ ::cs::rqstSend "${name}" "SetDisplayTimerOption" \
	"Set the option to display the module timer" \
	"int display_time\n" \
	1 \
	$format \
	$args ]
}


proc ::MPC_avoidObsSetDisplayTimerOptionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSetDisplayTimerOption
interp hide {} MPC_avoidObsSetDisplayTimerOptionFormatOutput





# Modemode ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsModemodePosterRead] >= 0 } {
    interp expose {} MPC_avoidObsModemodePosterRead
}
if { [lsearch [interp hidden] MPC_avoidObsModemodePosterFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsModemodePosterFormatOutput
}

proc ::MPC_avoidObsModemodePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Modemode" \
	"int mode\n" \
	$args ]
}


proc ::MPC_avoidObsModemodePosterFormatOutput { list } {
    set format { {} status { } mode }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsModemodePosterRead
interp hide {} MPC_avoidObsModemodePosterFormatOutput





# CTrajctraj ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsCTrajctrajPosterRead] >= 0 } {
    interp expose {} MPC_avoidObsCTrajctrajPosterRead
}
if { [lsearch [interp hidden] MPC_avoidObsCTrajctrajPosterFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsCTrajctrajPosterFormatOutput
}

proc ::MPC_avoidObsCTrajctrajPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "CTrajctraj" \
	"MANA_PCTRAJ\n| POLY_MULTIITV\n| | POLY_ITV\n| | | POLYNOME4\n| | | | float a\n| | | | float b\n| | | | float c\n| | | | float d\n| | | ITV\n| | | | float binf\n| | | | float bsup\n| | int n\n| POLY_MULTIITV\n| | POLY_ITV\n| | | POLYNOME4\n| | | | float a\n| | | | float b\n| | | | float c\n| | | | float d\n| | | ITV\n| | | | float binf\n| | | | float bsup\n| | int n\n| TIMEV\n| | long long int sec\n| | long long int usec\n| TIMEV\n| | long long int sec\n| | long long int usec\n" \
	$args ]
}


proc ::MPC_avoidObsCTrajctrajPosterFormatOutput { list } {
    set format { {} status { } { ctraj { } { vel { 15 } { tabItv { } { poly { } a { } b { } c { } d } { } { itv { } binf { } bsup } } { } n } { } { avel { 15 } { tabItv { } { poly { } a { } b { } c { } d } { } { itv { } binf { } bsup } } { } n } { } { t0 { } sec { } usec } { } { tf { } sec { } usec } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsCTrajctrajPosterRead
interp hide {} MPC_avoidObsCTrajctrajPosterFormatOutput





# STrajstraj ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsSTrajstrajPosterRead] >= 0 } {
    interp expose {} MPC_avoidObsSTrajstrajPosterRead
}
if { [lsearch [interp hidden] MPC_avoidObsSTrajstrajPosterFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsSTrajstrajPosterFormatOutput
}

proc ::MPC_avoidObsSTrajstrajPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "STrajstraj" \
	"MANA_PSTRAJ\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n| MANA_PCTRAJ\n| | POLY_MULTIITV\n| | | POLY_ITV\n| | | | POLYNOME4\n| | | | | float a\n| | | | | float b\n| | | | | float c\n| | | | | float d\n| | | | ITV\n| | | | | float binf\n| | | | | float bsup\n| | | int n\n| | POLY_MULTIITV\n| | | POLY_ITV\n| | | | POLYNOME4\n| | | | | float a\n| | | | | float b\n| | | | | float c\n| | | | | float d\n| | | | ITV\n| | | | | float binf\n| | | | | float bsup\n| | | int n\n| | TIMEV\n| | | long long int sec\n| | | long long int usec\n| | TIMEV\n| | | long long int sec\n| | | long long int usec\n" \
	$args ]
}


proc ::MPC_avoidObsSTrajstrajPosterFormatOutput { list } {
    set format { {} status { } { straj { } { p0 { } x { } y { } theta } { } { pctraj { } { vel { 15 } { tabItv { } { poly { } a { } b { } c { } d } { } { itv { } binf { } bsup } } { } n } { } { avel { 15 } { tabItv { } { poly { } a { } b { } c { } d } { } { itv { } binf { } bsup } } { } n } { } { t0 { } sec { } usec } { } { tf { } sec { } usec } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsSTrajstrajPosterRead
interp hide {} MPC_avoidObsSTrajstrajPosterFormatOutput





# BestPathTSbestPath ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsBestPathTSbestPathPosterRead] >= 0 } {
    interp expose {} MPC_avoidObsBestPathTSbestPathPosterRead
}
if { [lsearch [interp hidden] MPC_avoidObsBestPathTSbestPathPosterFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsBestPathTSbestPathPosterFormatOutput
}

proc ::MPC_avoidObsBestPathTSbestPathPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "BestPathTSbestPath" \
	"GEN_PATH_XY\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n| int status\[100\]\n| int nbPos\n" \
	$args ]
}


proc ::MPC_avoidObsBestPathTSbestPathPosterFormatOutput { list } {
    set format { {} status { } { bestPath { 100 } { tab { } x { } y { } theta } { 100 } status { } nbPos } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsBestPathTSbestPathPosterRead
interp hide {} MPC_avoidObsBestPathTSbestPathPosterFormatOutput





# CandPathTStabCandPath_user ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsCandPathTStabCandPath_userPosterRead] >= 0 } {
    interp expose {} MPC_avoidObsCandPathTStabCandPath_userPosterRead
}
if { [lsearch [interp hidden] MPC_avoidObsCandPathTStabCandPath_userPosterFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsCandPathTStabCandPath_userPosterFormatOutput
}

proc ::MPC_avoidObsCandPathTStabCandPath_userPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "CandPathTStabCandPath_user" \
	"TAB_CAND_PATH\n| CAND_PATH_XY\n| | GENPOS_CART_CONFIG\n| | | double x\n| | | double y\n| | | double theta\n| | int nbPos\n| int nbPath\n" \
	$args ]
}


proc ::MPC_avoidObsCandPathTStabCandPath_userPosterFormatOutput { list } {
    set format { {} status { } { tabCandPath_user { 500 } { tab { 15 } { tab { } x { } y { } theta } { } nbPos } { } nbPath } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsCandPathTStabCandPath_userPosterRead
interp hide {} MPC_avoidObsCandPathTStabCandPath_userPosterFormatOutput





# ATFwaypointsatf_waypoints_user ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsATFwaypointsatf_waypoints_userPosterRead] >= 0 } {
    interp expose {} MPC_avoidObsATFwaypointsatf_waypoints_userPosterRead
}
if { [lsearch [interp hidden] MPC_avoidObsATFwaypointsatf_waypoints_userPosterFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsATFwaypointsatf_waypoints_userPosterFormatOutput
}

proc ::MPC_avoidObsATFwaypointsatf_waypoints_userPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "ATFwaypointsatf_waypoints_user" \
	"PL_PATH_XY\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n| int nbPos\n" \
	$args ]
}


proc ::MPC_avoidObsATFwaypointsatf_waypoints_userPosterFormatOutput { list } {
    set format { {} status { } { atf_waypoints_user { 5000 } { tab { } x { } y { } theta } { } nbPos } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsATFwaypointsatf_waypoints_userPosterRead
interp hide {} MPC_avoidObsATFwaypointsatf_waypoints_userPosterFormatOutput





# DistObsMapdistObsMap_user ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_avoidObsDistObsMapdistObsMap_userPosterRead] >= 0 } {
    interp expose {} MPC_avoidObsDistObsMapdistObsMap_userPosterRead
}
if { [lsearch [interp hidden] MPC_avoidObsDistObsMapdistObsMap_userPosterFormatOutput] >= 0 } {
    interp expose {} MPC_avoidObsDistObsMapdistObsMap_userPosterFormatOutput
}

proc ::MPC_avoidObsDistObsMapdistObsMap_userPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "DistObsMapdistObsMap_user" \
	"DIST_OBS_MAP\n| int dimX\n| int dimY\n| float xOrigin\n| float yOrigin\n| float xScale\n| float yScale\n| int cellState\[250\]\[250\]\n| POS_CELL_XY\n| | int x\n| | int y\n| float thresSlope\n| float thresVarSlope\n| float safeDist\n| float padding\n" \
	$args ]
}


proc ::MPC_avoidObsDistObsMapdistObsMap_userPosterFormatOutput { list } {
    set format { {} status { } { distObsMap_user { } dimX { } dimY { } xOrigin { } yOrigin { } xScale { } yScale { 250 250 } cellState { 250 250 } { dist { } x { } y } { } thresSlope { } thresVarSlope { } safeDist { } padding } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_avoidObsDistObsMapdistObsMap_userPosterRead
interp hide {} MPC_avoidObsDistObsMapdistObsMap_userPosterFormatOutput


